#!/usr/bin/perl
#<
#Author: Robert Clapp, ESMB 463, 7230253
#
#Date Created:Mon Jun  7 21:59:32 PDT 1999
#

$relative="NONE";
$fullsep="yes";
$sep_doc=$0;
$sep_doc=~s/ratsep/sep_doc_it/gm;

if($0=~/^(.+)\/include\/ratsep$/){ $builddir=$1;
 if($fullsep eq "no"){ $RATFOR90="ratfor90"; }
	elsif($relative eq "NONE"){ $RATFOR90="$builddir/../ratfor90/ratfor90"; }
	else{$RATFOR90="$builddir/../../ratfor90/$relative/ratfor90";}
}
else{ $RATFOR90="ratfor90"; }


$cppargs=""; 
$fargs="@F90_DO@ ";
$redo=0;
if($fargs =~/ifc_f90 $/){ $redo=1; $f="ifc_f90";}
if($fargs =~/v_f90 $/){ $redo=1; $f="v_f90";}
if($redo==1){
	$fargs="$builddir/include/$f ";
}
	


$do_f90=0;
$main=0;
$sep="-sep";
foreach $arg (@ARGV){
  if($arg =~ /^-DSOURCE=(.+)$/){$fpp_s="-DSOURCE='$1'"; $rat90.=" $arg ";}
  elsif($arg =~ /^-D/){ $cppargs.=" $arg ";}
  elsif($arg =~ /-dof90$/){$do_f90=1;}
  elsif($arg =~ /-sepmain$/){$main=1;$sep="-sepmain";}
  elsif($arg =~ /ratsep$/){}
  elsif($arg =~ /\.r90$/){}
  elsif($arg =~ /\.rs90$/){}
  elsif($arg =~ /\.lop$/){}
  elsif($arg =~ /\.F90$/){}
  elsif($arg =~ /\.f90$/){}
  else { $fargs.="$arg ";}
  $file=$arg;
}
if($main==1) { $sep_doc_it="|$sep_doc_it ";}
if($do_f90==1) { $rat90=" -DSOURCE=SOURCE";}

	
if($0=~/^(.+)include\/ratsep$/){
$base=$1;
}
elsif($0=~/(.+\/bin\/)ratsep$/){ $base=$1;
}
else {
        print STDERR "Unrecognized calling pattern $0  \n";
        exit 1;
}
$SAW="$base"."tools/autowriters/saw/saw90 $base/tools/autowriters/saw";
$FPP="$base"."tools/spp/spp";



if($file=~/^(.+)\.(\S+)$/){$ext=$2;$rest=$1;
 if($rest=~/^(.+\/)(.+)$/){$dir=$1; $b=$2;}
  else{ $b=$rest; $dir="./";}
  $output="$b".".o";$base="$dir"."$b";
  $fargs.=" -o $output";
  if($do_f90==0){
	  if($ext eq "F90"){
	  	@commands=( 
	  		"$FPP  < $base.F90 $cppargs $fpp_s >$base.fix.f90",
		  	"$fargs $base.fix.f90",
		  	"/usr/bin/rm  $base.fix.f90"
	  		);
	  }
	  elsif($ext eq "f90"){
	  	@commands=( 
	  		"$fargs $base.f90"
	  		);
	  }
	  elsif($ext eq "r90"){
	  	@commands=( 
	  		"$RATFOR90 <$file $rat90 | $FPP  $cppargs >$base.f90",
	  		"$fargs $base.f90",
	  		"/usr/bin/rm  $base.f90"
	  		);
	  }
	  elsif($ext eq "clop"){
	  	@commands=( 
	  		"$RATFOR90 <$file $rat90 $sep -dcomplex  | $FPP   $cppargs >$base.f90",
	  		"$fargs $base.f90",
	  		"/usr/bin/rm  $base.f90"
	  		);
	  }
	  elsif($ext eq "rs90" || $ext eq "lop"){
	  	@commands=( 
	  		"$RATFOR90 <$file $rat90 $sep $sep_doc_it | $FPP   $cppargs >$base.f90",
	  		"$fargs $base.f90",
	  		"/usr/bin/rm  $base.f90"
	  		);
	  }
	  elsif($ext eq "fs90"){
	  	@commands=( 
	  		"$SAW $file | $FPP   $cppargs $rat90>$base.f90",
	  		"$fargs $base.f90",
	  		"/usr/bin/rm  $base.f90"
	  		);
	  }
	  else{
	  	print STDERR "Unrecognized extension $ext \n";
	  	exit 1;
	  }
 } 
 else{ 
	  if($ext eq "F90"){
	  	@commands=( 
        "echo $base.F90  already in correct form "
	  		);
	  }
	  elsif($ext eq "f90"){
	  	@commands=( 
         "cp $file $base.F90sep"
	  		);
	  }
	  elsif($ext eq "r90"){
	  	@commands=( 
	  		"$RATFOR90 <$file $rat90  >$base.F90"
	  		);
	  }
	  elsif($ext eq "clop"){
	  	@commands=( 
	  		"$RATFOR90 <$file $rat90 $sep -dcomplex  | $FPP   $cppargs >$base.F90"
	  		);
	  }
	  elsif($ext eq "rs90" || $ext eq "lop"){
	  	@commands=( 
	  		"$RATFOR90 <$file $rat90 $sep     >$base.F90sep"
	  		);
	  }
	  elsif($ext eq "fs90"){
	  	@commands=( 
	  		"$SAW $file  $rat90>$base.F90"
	  		);
	  }
	  else{
	  	print STDERR "Unrecognized extension $ext \n";
	  	exit 1;
	  }
 } 
}
else{
	print STDERR "Unrecognized file type $file \n";
	exit 1;
}

for($i=0; $i < @commands; $i++){
	print STDERR "$i: $commands[$i]\n";
	$exit=system($commands[$i]);
	if($exit/256 !=0){ exit $exit/256;}
}
exit 0;
