
if(present(local_tag)) my_local=local_tag
else if(struct%nmpi>1) my_local=.false.
else my_local=.true.

if(.not. valid_structure(struct)) call erexit("not a valid sep structure\n");
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");

n=struct%ndims
allocate(nt(n),ft(n),jt(n))

if(present(nwind)) nt=nwind
else nt=-1

if(present(fwind)) ft=fwind
else ft=-1

if(present(jwind)) jt=jwind
else jt=-1

if(present(write_grid)){
	if(struct%file_format!="GRID" && write_grid) 
		call erexit("can not write grid when file_format not grid \n");
	if(write_grid) wg=1;
	else  wg=0;
}
else{
	if(struct%file_format!="GRID") wg=0
  else wg=1
}



ierr=sep3d_grab_nh(struct%tag,nh)
if(present(write_headers)){
	if(struct%file_format=="REGULAR" && write_headers)
		call erexit("file_format set to regular can not write out headers \n");
	if(write_headers) wh=1
	else wh=0
}
else{
	ierr=sep3d_grab_nh(struct%tag,nh)
	if(nh==0)  wh=0
	else wh=1
}

if(wd==1 && wh==1){
	ntm=size(tempp,2)
	if(wh == 1 && ntm != nh) {
		write(0,*) "number of traces",ntm,"number of headers",nh
		call erexit("f90rite:number of traces not equal to the number of traces being  stored\n");
	}
}
call fix_vector(struct%n,ft,jt,nt)


!if(wg==1 || wh==1){
  if(struct%nsect >1){
	    if(0!=sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt,tempp, gp,
        wd,wh,wg))
	    	call erexit("trouble writing out the data \n");
  }
  else{
    if(struct%impi==0  || struct%nmpi==1) {
	    if(0!=sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg))
	    	call erexit("trouble writing out the data \n");
    }
  }
!}else if(wd==1){
!	if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!		call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
	

deallocate(nt,ft,jt)
